(defvar f1        "eval"           )
(defvar f2        "toString"       )
;(defvar c1        "Const"          )
;(defvar c2        "Add"            )
(defvar f1mod     "EvalMod"        )
(defvar f2mod     "ToStringMod"    )
;(defvar f1c1      (concat f1 c1)   )
;(defvar f1c2      (concat f1 c2)   )
;(defvar f2c1      (concat f2 c1)   )
;(defvar f2c2      (concat f2 c2)   )
;(defvar c1mod     (concat c1 "Mod")) ;; Warning, here the form of c1mod and c2 mod 
;(defvar c2mod     (concat c2 "Mod")) ;; depends on the implementation of moveAllDefsToConstructorModulesFollowingPatternMatching.
(defvar f1prefix  (concat "tmp" f1) ) ;; Warning, here f1prefix and f2prefix must not occur
(defvar f2prefix  (concat "tmp" f2) ) ;; as a prefix in existing functions in the program.


;; 1- set branches as local definitions (preliminary to exhibit business functions)
(haskell-refac-newDefAllEqBodiesIn f1 f1prefix f1mod)
(haskell-refac-newDefAllEqBodiesIn f2 f2prefix f2mod)



; 2- abstract these definitions over local arguments to create business functions
(haskell-refac-generaliseAllPatternVariablesInAllLocalDefsIn f1 f1prefix f1mod) 
(haskell-refac-generaliseAllPatternVariablesInAllLocalDefsIn f2 f2prefix f2mod) 





;; 3- make main functions abstract in business functions to avoid circular dependencies
(haskell-refac-generaliseIdentInAllLocalDefsIn f1 f1prefix f1 "cont" f1mod)  
(haskell-refac-generaliseIdentInAllLocalDefsIn f2 f2prefix f2 "cont" f2mod)  

;; 4- lift the business functions to the top-level
(haskell-refac-liftAllLocalDefsToTopLevelIn f1 f1prefix f1mod)                
(haskell-refac-liftAllLocalDefsToTopLevelIn f2 f2prefix f2mod)                



;; 5- move business functions to the appropriate modules
(haskell-refac-moveAllDefsToConstructorModulesFollowingPatternMatching f1 f1prefix f1mod)
(haskell-refac-moveAllDefsToConstructorModulesFollowingPatternMatching f2 f2prefix f2mod)



;; 6- rename the business functions to make them share the same name
(haskell-refac-renameAllIdentsIn f1 f1prefix f1mod)
(haskell-refac-renameAllIdentsIn f2 f2prefix f2mod)

